import pandas as pd
import xlsxwriter


def matrixToxls(matrix, filename):
    workbook = xlsxwriter.Workbook(filename)
    worksheet = workbook.add_worksheet()
    row = 0
    for col, data in enumerate(matrix):
        worksheet.write_column(row, col, data)
    workbook.close()


def exulidean(row1, row2):
    s = 0
    for p, q in zip(row1, row2):
        s += ((p - q) ** 2)
    return s ** 0.5


if __name__ == "__main__":
    df = pd.read_excel('dataset2.xls', sheet_name="forestfires").to_numpy()
    resultEculidean = []
    for row in df:
        tmp = []
        for row2 in df:
            tmp.append(exulidean(row, row2))  # [0,x,    ]
        resultEculidean.append(tmp)
    matrixToxls(resultEculidean, "eculidean.xls")
